---
hide:
  - navigation
---

# Contributing

## Prerequisites

Reviewing the following will prepare you for contributing:

* You should be comfortable with git. Most contributions follow the GitHub workflow of fork, branch, commit, open pull request, review changes, and merge to work effectively in the KubeVirt community.  If you're new to git, [git-scm.com](https://git-scm.com/doc) has a nice set of tutorials.
* Familiarize yourself with the various repositories of the [KubeVirt](https://github.com/kubevirt) GitHub organization.
* Try the one of our [quick start labs](https://kubevirt.io/user-guide/) on [killercoda](https://killercoda.com/kubevirt), [minikube](https://kubevirt.io/quickstart_minikube/), or [kind](https://kubevirt.io/quickstart_kind/).
* See the "Other ways to contribute" section below.

For code contributors:

* You need to be familiar with writing code in golang.  See the [golang tour](https://tour.golang.org/welcome/1) to familiarize yourself.
* Read the Developer [contribution page](https://github.com/kubevirt/kubevirt/blob/main/CONTRIBUTING.md) and the [getting started page](https://github.com/kubevirt/kubevirt/blob/main/docs/getting-started.md).

## Your first contribution

The following will help you decide where to start

* Check a repository issues list and label `good-first-issue` for issues that make good entry points.
* Open a pull request using GitHub to documentation. The tutorials found here can be helpful https://lab.github.com/
* Review a pull request from other community members for accuracy and language.

## Other ways to contribute

* Visit the KubeVirt [community page](https://kubevirt.io/community/), participate on Twitter or Slack, learn about local meetups and events.
* Visit the KubeVirt [website repository](https://github.com/kubevirt/kubevirt.github.io) and submit a blog post, case study or lab.
* Visit the KubeVirt [user-guide repository](https://github.com/kubevirt/user-guide) and find feature documentation that could use an update.
